﻿// <auto-generated />
using System;
using Accounting.API.DataContext;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace Accounting.API.Migrations
{
    [DbContext(typeof(AccountingDataContext))]
    [Migration("20190419131022_bugfix-table-accountType")]
    partial class bugfixtableaccountType
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                .HasAnnotation("ProductVersion", "2.2.4-servicing-10062")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            modelBuilder.Entity("Accounting.API.DataContext.AccountType", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountTypeCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("AccountTypeName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("AccountTypeCode")
                        .IsUnique();

                    b.ToTable("AccountTypes");
                });

            modelBuilder.Entity("Accounting.API.DataContext.Bank", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("BankCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("BankName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("City")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("ContactPersonName")
                        .HasMaxLength(64);

                    b.Property<string>("ContactPersonPhone")
                        .HasMaxLength(24);

                    b.Property<string>("Country")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("Fax")
                        .HasMaxLength(64);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Phone")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("Phone2")
                        .HasMaxLength(24);

                    b.Property<string>("Province")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("WebAddress")
                        .HasMaxLength(256);

                    b.Property<string>("ZipCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.HasKey("Id");

                    b.HasIndex("BankCode")
                        .IsUnique();

                    b.ToTable("Banks");
                });

            modelBuilder.Entity("Accounting.API.DataContext.BankAccount", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("AccountNumber")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<Guid>("BankId");

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<bool>("IsActive");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("AccountNumber")
                        .IsUnique();

                    b.HasIndex("BankId");

                    b.ToTable("BankAccounts");
                });

            modelBuilder.Entity("Accounting.API.DataContext.CashPayment", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("BankCode")
                        .HasMaxLength(24);

                    b.Property<string>("BankName")
                        .HasMaxLength(64);

                    b.Property<DateTime>("CashPaymentDate");

                    b.Property<string>("CashPaymentNo")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CashPaymentStatus")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CcEmail")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("CurrencyCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasMaxLength(512);

                    b.Property<string>("DivisionName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("EmployeeCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("EmployeeName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("Location")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<DateTime?>("PaymentDocumentEffectiveDate");

                    b.Property<DateTime?>("PaymentDocumentExpiredDate");

                    b.Property<string>("PaymentDocumentNo")
                        .HasMaxLength(24);

                    b.Property<string>("PaymentDocumentRemark")
                        .HasMaxLength(128);

                    b.Property<string>("PaymentDocumentType")
                        .HasMaxLength(24);

                    b.Property<string>("Position")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("ReceiverCode")
                        .HasMaxLength(24);

                    b.Property<string>("ReceiverName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("ReceiverType")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime?>("RefDocumentDate");

                    b.Property<string>("RefDocumentNo")
                        .HasMaxLength(24);

                    b.Property<string>("RefDocumentType")
                        .HasMaxLength(24);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("StatusApproval")
                        .HasMaxLength(24);

                    b.Property<decimal>("TotalPayment");

                    b.HasKey("Id");

                    b.HasIndex("CashPaymentNo")
                        .IsUnique();

                    b.ToTable("CashPayments");
                });

            modelBuilder.Entity("Accounting.API.DataContext.CashReceipt", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("BankCode")
                        .HasMaxLength(24);

                    b.Property<string>("BankName")
                        .HasMaxLength(64);

                    b.Property<DateTime>("CashReceiptDate");

                    b.Property<string>("CashReceiptNo")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CashReceiptStatus")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CcEmail")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("CurrencyCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasMaxLength(512);

                    b.Property<string>("DivisionName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("EmployeeCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("EmployeeName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("Location")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<string>("PayerCode")
                        .HasMaxLength(24);

                    b.Property<string>("PayerName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("PayerType")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("Position")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<DateTime?>("ReceiptDocumentEffectiveDate");

                    b.Property<DateTime?>("ReceiptDocumentExpiredDate");

                    b.Property<string>("ReceiptDocumentNo")
                        .HasMaxLength(24);

                    b.Property<string>("ReceiptDocumentRemark")
                        .HasMaxLength(128);

                    b.Property<string>("ReceiptDocumentType")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("RefDocumentDate");

                    b.Property<string>("RefDocumentNo")
                        .HasMaxLength(24);

                    b.Property<string>("RefDocumentType")
                        .HasMaxLength(24);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("StatusApproval")
                        .HasMaxLength(24);

                    b.Property<decimal>("TotalPayment");

                    b.HasKey("Id");

                    b.HasIndex("CashReceiptNo")
                        .IsUnique();

                    b.ToTable("CashReceipts");
                });

            modelBuilder.Entity("Accounting.API.DataContext.CategoryAccount", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountCategoryCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("AccountCategoryName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("AccountCategoryCode")
                        .IsUnique();

                    b.ToTable("CategoryAccounts");
                });

            modelBuilder.Entity("Accounting.API.DataContext.CategoryCustomer", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("CategoryName")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<short>("Priority");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("CategoryName")
                        .IsUnique();

                    b.ToTable("CategoryCustomers");
                });

            modelBuilder.Entity("Accounting.API.DataContext.CategorySupplier", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("CategoryName")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<short>("Priority");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("CategoryName")
                        .IsUnique();

                    b.ToTable("CategorySuppliers");
                });

            modelBuilder.Entity("Accounting.API.DataContext.ChartOfAccount", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<short>("AccountLevel");

                    b.Property<string>("AccountName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<Guid>("AccountTypeId");

                    b.Property<Guid>("CategoryAccountId");

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<short?>("DefaultValue");

                    b.Property<bool>("IsAccountDetail");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<Guid?>("ParentId");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("SchemaCode")
                        .IsRequired()
                        .HasMaxLength(5);

                    b.HasKey("Id");

                    b.HasIndex("AccountCode")
                        .IsUnique();

                    b.HasIndex("AccountTypeId");

                    b.HasIndex("CategoryAccountId");

                    b.ToTable("ChartOfAccounts");
                });

            modelBuilder.Entity("Accounting.API.DataContext.Currency", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<decimal>("BaseRate");

                    b.Property<decimal>("BaseValue");

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("CurrencyCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CurrencyName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<DateTime>("ExchangeDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("CurrencyCode")
                        .IsUnique();

                    b.ToTable("Currencys");
                });

            modelBuilder.Entity("Accounting.API.DataContext.Customer", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<Guid>("CategoryCustomerId");

                    b.Property<string>("City")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("ContactPersonName")
                        .HasMaxLength(64);

                    b.Property<string>("ContactPersonPhone")
                        .HasMaxLength(24);

                    b.Property<string>("Country")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("CustomerCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CustomerName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("Fax")
                        .HasMaxLength(64);

                    b.Property<bool>("IsActive");

                    b.Property<double>("MinimumDownPayment");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<string>("Phone")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("Phone2")
                        .HasMaxLength(24);

                    b.Property<string>("Province")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("WebAddress")
                        .HasMaxLength(256);

                    b.Property<string>("ZipCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.HasKey("Id");

                    b.HasIndex("CategoryCustomerId");

                    b.HasIndex("CustomerCode")
                        .IsUnique();

                    b.ToTable("Customers");
                });

            modelBuilder.Entity("Accounting.API.DataContext.CustomerShipment", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("Carrier")
                        .HasMaxLength(256);

                    b.Property<string>("City")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("Consignee")
                        .HasMaxLength(256);

                    b.Property<string>("Country")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<Guid>("CustomerId");

                    b.Property<bool>("IsDefaultShipment");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<string>("PortOfDestination")
                        .HasMaxLength(256);

                    b.Property<string>("PortOfOrigin")
                        .HasMaxLength(256);

                    b.Property<string>("Province")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("ZipCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.HasKey("Id");

                    b.HasIndex("CustomerId");

                    b.ToTable("CustomerShipments");
                });

            modelBuilder.Entity("Accounting.API.DataContext.FiscalYear", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<short>("ClosingType");

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<DateTime>("EndDate");

                    b.Property<string>("FiscalYearCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("FiscalYearName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<DateTime>("StartDate");

                    b.HasKey("Id");

                    b.HasIndex("FiscalYearCode")
                        .IsUnique();

                    b.ToTable("FiscalYears");
                });

            modelBuilder.Entity("Accounting.API.DataContext.GeneralLedger", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("CcEmail")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("CurrencyCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("DivisionName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("EmployeeCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("EmployeeName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("FiscalYearCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("GeneralLedgerDate");

                    b.Property<string>("GeneralLedgerName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("GeneralLedgerNo")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("GeneralLedgerType")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<bool>("IsLastBalance");

                    b.Property<string>("Location")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<string>("Position")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<DateTime>("PostingDate");

                    b.Property<string>("ReffDocumentCode")
                        .HasMaxLength(24);

                    b.Property<string>("ReffDocumentName")
                        .HasMaxLength(24);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("StatusApproval")
                        .HasMaxLength(24);

                    b.Property<decimal>("TotalCredit");

                    b.Property<decimal>("TotalDebet");

                    b.Property<DateTime>("TransactionDate");

                    b.Property<string>("TransactionType")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.HasKey("Id");

                    b.HasIndex("GeneralLedgerNo")
                        .IsUnique();

                    b.ToTable("GeneralLedgers");
                });

            modelBuilder.Entity("Accounting.API.DataContext.GeneralLedgerDetail", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("AccountName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<decimal>("Credit");

                    b.Property<string>("CurrencyCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<decimal>("Debet");

                    b.Property<decimal>("ExchangeRate");

                    b.Property<decimal>("ExchangeValueCredit");

                    b.Property<decimal>("ExchangeValueDebet");

                    b.Property<Guid>("GeneralLedgerId");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("GeneralLedgerId");

                    b.ToTable("GeneralLedgerDetails");
                });

            modelBuilder.Entity("Accounting.API.DataContext.ReportBalanceSheet", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<int>("AccountLevel");

                    b.Property<string>("AccountName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<decimal>("Credit");

                    b.Property<decimal>("Debet");

                    b.Property<bool>("IsAccountDetail");

                    b.Property<int>("LineNumber");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<decimal>("Saldo");

                    b.Property<Guid>("SessionId");

                    b.HasKey("Id");

                    b.ToTable("ReportBalanceSheets");
                });

            modelBuilder.Entity("Accounting.API.DataContext.ReportIncomeStatement", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<bool>("IsDetail");

                    b.Property<int>("LineLevel");

                    b.Property<int>("LineNumber");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<decimal>("Saldo");

                    b.Property<Guid>("SessionId");

                    b.HasKey("Id");

                    b.ToTable("ReportIncomeStatements");
                });

            modelBuilder.Entity("Accounting.API.DataContext.ReportPattern", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<string>("ReportName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("ReportName")
                        .IsUnique();

                    b.ToTable("ReportPatterns");
                });

            modelBuilder.Entity("Accounting.API.DataContext.ReportPatternDetail", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("AccountCode")
                        .HasMaxLength(24);

                    b.Property<int>("AccountLevel");

                    b.Property<string>("AccountName")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("FunctionAccount")
                        .HasMaxLength(64);

                    b.Property<string>("FunctionFormula");

                    b.Property<string>("FunctionValue")
                        .IsRequired()
                        .HasMaxLength(64);

                    b.Property<bool>("IsAccountDetail");

                    b.Property<int>("LineNumber");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<Guid>("ReportPatternId");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("ReportPatternId");

                    b.ToTable("ReportPatternDetails");
                });

            modelBuilder.Entity("Accounting.API.DataContext.SubsidiaryAccountsPayable", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("SupplierCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("SupplierName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.HasKey("Id");

                    b.ToTable("SubsidiaryAccountsPayables");
                });

            modelBuilder.Entity("Accounting.API.DataContext.SubsidiaryAccountsPayableDetail", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<decimal>("Balance");

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<decimal>("Credit");

                    b.Property<decimal>("Debet");

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasMaxLength(512);

                    b.Property<string>("DocumentNo")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("DocumentType")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<Guid>("SubsidiaryAccountsPayableId");

                    b.Property<DateTime>("TransactionDate");

                    b.HasKey("Id");

                    b.HasIndex("SubsidiaryAccountsPayableId");

                    b.ToTable("SubsidiaryAccountsPayableDetails");
                });

            modelBuilder.Entity("Accounting.API.DataContext.SubsidiaryAccountsReceivable", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("CustomerCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("CustomerName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.HasKey("Id");

                    b.ToTable("SubsidiaryAccountsReceivables");
                });

            modelBuilder.Entity("Accounting.API.DataContext.SubsidiaryAccountsReceivableDetail", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<decimal>("Balance");

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<decimal>("Credit");

                    b.Property<decimal>("Debet");

                    b.Property<string>("Description")
                        .IsRequired()
                        .HasMaxLength(512);

                    b.Property<string>("DocumentNo")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("DocumentType")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<Guid>("SubsidiaryAccountsReceivableId");

                    b.Property<DateTime>("TransactionDate");

                    b.HasKey("Id");

                    b.HasIndex("SubsidiaryAccountsReceivableId");

                    b.ToTable("SubsidiaryAccountsReceivableDetails");
                });

            modelBuilder.Entity("Accounting.API.DataContext.Supplier", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<Guid>("CategorySupplierId");

                    b.Property<string>("City")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("ContactPersonName")
                        .HasMaxLength(64);

                    b.Property<string>("ContactPersonPhone")
                        .HasMaxLength(24);

                    b.Property<string>("Country")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("CreatedBy")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<DateTime>("CreatedDate");

                    b.Property<string>("DefaultCurrency")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<decimal>("DefaultFreightCost");

                    b.Property<decimal>("DefaultOtherCost");

                    b.Property<decimal>("DefaultOtherCostRemark")
                        .HasMaxLength(128);

                    b.Property<decimal>("DefaultOtherTax");

                    b.Property<decimal>("DefaultOtherTaxRemark")
                        .HasMaxLength(128);

                    b.Property<string>("DefaultPaymentType")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<decimal>("DefaultVAT");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(256);

                    b.Property<string>("Fax")
                        .HasMaxLength(64);

                    b.Property<bool>("IsActive");

                    b.Property<string>("ModifiedBy")
                        .HasMaxLength(24);

                    b.Property<DateTime?>("ModifiedDate");

                    b.Property<string>("Notes")
                        .HasMaxLength(512);

                    b.Property<string>("Phone")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("Phone2")
                        .HasMaxLength(24);

                    b.Property<string>("Province")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<byte>("RowStatus");

                    b.Property<byte[]>("RowVersion")
                        .IsRequired();

                    b.Property<string>("SupplierCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.Property<string>("SupplierName")
                        .IsRequired()
                        .HasMaxLength(128);

                    b.Property<string>("WebAddress")
                        .HasMaxLength(256);

                    b.Property<string>("ZipCode")
                        .IsRequired()
                        .HasMaxLength(24);

                    b.HasKey("Id");

                    b.HasIndex("CategorySupplierId");

                    b.HasIndex("SupplierCode")
                        .IsUnique();

                    b.ToTable("Suppliers");
                });

            modelBuilder.Entity("Accounting.API.DataContext.BankAccount", b =>
                {
                    b.HasOne("Accounting.API.DataContext.Bank", "Bank")
                        .WithMany("BankAccounts")
                        .HasForeignKey("BankId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.ChartOfAccount", b =>
                {
                    b.HasOne("Accounting.API.DataContext.AccountType", "AccountType")
                        .WithMany("ChartOfAccounts")
                        .HasForeignKey("AccountTypeId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("Accounting.API.DataContext.CategoryAccount", "CategoryAccount")
                        .WithMany("ChartOfAccounts")
                        .HasForeignKey("CategoryAccountId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.Customer", b =>
                {
                    b.HasOne("Accounting.API.DataContext.CategoryCustomer", "CategoryCustomer")
                        .WithMany("Customers")
                        .HasForeignKey("CategoryCustomerId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.CustomerShipment", b =>
                {
                    b.HasOne("Accounting.API.DataContext.Customer", "Customer")
                        .WithMany("CustomerShipments")
                        .HasForeignKey("CustomerId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.GeneralLedgerDetail", b =>
                {
                    b.HasOne("Accounting.API.DataContext.GeneralLedger", "GeneralLedger")
                        .WithMany("GeneralLedgerDetails")
                        .HasForeignKey("GeneralLedgerId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.ReportPatternDetail", b =>
                {
                    b.HasOne("Accounting.API.DataContext.ReportPattern", "ReportPattern")
                        .WithMany("ReportPatternDetails")
                        .HasForeignKey("ReportPatternId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.SubsidiaryAccountsPayableDetail", b =>
                {
                    b.HasOne("Accounting.API.DataContext.SubsidiaryAccountsPayable", "SubsidiaryAccountsPayable")
                        .WithMany("SubsidiaryAccountsPayableDetails")
                        .HasForeignKey("SubsidiaryAccountsPayableId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.SubsidiaryAccountsReceivableDetail", b =>
                {
                    b.HasOne("Accounting.API.DataContext.SubsidiaryAccountsReceivable", "SubsidiaryAccountsReceivable")
                        .WithMany("SubsidiaryAccountsReceivableDetails")
                        .HasForeignKey("SubsidiaryAccountsReceivableId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Accounting.API.DataContext.Supplier", b =>
                {
                    b.HasOne("Accounting.API.DataContext.CategorySupplier", "CategorySupplier")
                        .WithMany("Suppliers")
                        .HasForeignKey("CategorySupplierId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
